//#pragma once
#ifndef CH_CHAN_H
#define CH_CHAN_H

#include <CGAL/basic.h>   //  na co? 
#include <iterator>


CGAL_BEGIN_NAMESPACE

// same as |convex_hull_2(first,last,result)|.
// {\sc traits}: uses |Traits::Point_2|, |Traits::Less_rotate_ccw_2|,
// |Traits::Equal_2| and |Traits::Less_xy_2|.
// call WITH Traits
template <class ForwardIterator, class OutputIterator, class Traits> 
OutputIterator 
ch_chan( ForwardIterator first, ForwardIterator last, 
		 OutputIterator result, 
		 const Traits& ch_traits );

// call WITHOUT Traits
template <class ForwardIterator, class OutputIterator> 
OutputIterator 
ch_chan( ForwardIterator first, ForwardIterator last, 
		 OutputIterator result )
{
	typedef std::iterator_traits<ForwardIterator> ITraits;
	typedef typename ITraits::value_type value_type;
	typedef CGAL::Kernel_traits<value_type> KTraits;;
	typedef typename KTraits::Kernel Kernel;

	return ch_chan( first, last, result, Kernel() ); 
}

CGAL_END_NAMESPACE

#include "ch_chan_impl.h"

#endif // CH_CHAN_H
